// import 'dart:async';

// import 'package:bloc_bus/src/state_magic_scope.dart';
// import 'package:flutter/widgets.dart';
// import 'package:rxdart/rxdart.dart';

// import 'base_bloc.dart';

// abstract class StateMagicBloc<E, S> {
//   final List<Type> events;

//   StateMagicBloc(
//     S initialState, {
//     this.events = const [],
//   });

//   @protected
//   bool get isAttached => context != null;

//   @protected
//   void Function(BuildContext)? context;

//   Stream<S> mapEventToState(E event);
// }

// class BaseBlocConsumer<E, S, B extends BaseBloc<E, S>> extends StatefulWidget {
//   final Widget Function(BuildContext context, S state, B bloc) builder;
//   final RebuildConditional? rebuildWhen;
//   final B bloc;

//   const BaseBlocConsumer({
//     Key? key,
//     required this.builder,
//     this.rebuildWhen,
//     required this.bloc,
//   }) : super(key: key);

//   Widget build(BuildContext context) {
//     return builder(context, bloc.initialState, bloc);
//   }

//   @override
//   _BaseBlocConsumerState createState() => _BaseBlocConsumerState<E, S, B>();
// }

// typedef RebuildConditional<S> = bool Function(S previousState, S nextState);

// class _BaseBlocConsumerState<E, S, B extends BaseBloc<E, S>>
//     extends State<BaseBlocConsumer> {
//   Stream<S>? stream;
//   StreamSubscription<S>? _rebuildSubscription;
//   late RebuildConditional rebuildWhen;
//   late S state;

//   @override
//   void initState() {
//     super.initState();
//     rebuildWhen = widget.rebuildWhen ?? RebuildConditionals.always;
//     state = widget.bloc.initialState;
//   }

//   @override
//   void dispose() {
//     _rebuildSubscription?.cancel();
//     super.dispose();
//   }

//   @override
//   Widget build(BuildContext context) {
//     if (widget.bloc is ScopeInteractor<E, S>) {
//       print("INIT");
//       stream ??= Rx.merge<S>(
//         [
//           (widget.bloc.stateStream as Stream<S>).distinct(rebuildWhen),
//           // (widget.bloc as ScopeInteractor).onAllOf<S>(context, {}),
//         ],
//       ).asBroadcastStream();
//       _rebuildSubscription ??= stream?.listen((s) => setState(() => state = s));
//     }
//     return widget.build(context);
//   }
// }

// // class StateMagicBlocConsumer<B extends StateMagicBloc, S>
// //     extends StatefulWidget {
// //   final B bloc;
// //   final Widget Function(BuildContext context, S state, B bloc) builder;

// //   const StateMagicBlocConsumer({
// //     Key? key,
// //     required this.bloc,
// //     required this.builder,
// //   }) : super(key: key);

// //   @override
// //   _StateMagicBlocConsumerState createState() =>
// //       _StateMagicBlocConsumerState<S>();
// // }

// // class _StateMagicBlocConsumerState<S> extends State<StateMagicBlocConsumer> {
// //   @override
// //   void initState() {
// //     super.initState();
// //   }

// //   @override
// //   void dispose() {
// //     super.dispose();
// //   }

// //   @override
// //   Widget build(BuildContext context) {
// //     final bloc = widget.bloc;

// //     return StreamBuilder(
// //       stream: StateMagicScope.of(context)
// //           .stream()
// //           .where((e) => bloc.events.contains(e.runtimeType))
// //           .distinct()
// //           .asyncExpand(bloc.mapEventToState),
// //       builder: (context, snapshot) {
// //         return widget.builder(context, snapshot.data, bloc);
// //       },
// //     );
// //   }
// // }

// abstract class RebuildConditionals {
//   static RebuildConditional get always => (_, __) => true;
//   static RebuildConditional get never => (_, __) => false;
//   static RebuildConditional get deepEquality => (s1, s2) => true;
// }

// mixin ScopeInteractor<E, S> on BaseBloc<E, S> {
//   IStateMagicScope? scope(BuildContext context) => StateMagicScope.of(context);

//   void pub(BuildContext context, Object event) {
//     final _scope = scope(context);
//     if (_scope == null) {
//       throw 'no scope found in tree';
//     } else {
//       _scope.fire(event);
//     }
//   }

//   void sub(BuildContext context, EventStateMapper eventStateMapper) {
//     final _scope = scope(context);
//     if (_scope == null) {
//       throw 'no scoupe found';
//     } else {
//       onAllOf(context, eventStateMapper);
//     }
//   }

//   EventStateMapper? eventStateMapper;

//   Stream<S> get stateStream => Rx.merge([]);

//   Stream<S> onAllOf<S>(
//       BuildContext context, EventStateMapper<Type, S> _eventStateMapper) {
//     eventStateMapper == null
//         ? eventStateMapper = eventStateMapper
//         : eventStateMapper
//       ?..addEntries(_eventStateMapper.entries);
//     final _scope = scope(context);

//     return _scope!.stream().where((event) => eventStateMapper!.keys
//         .where((eventType) => event.runtimeType == eventType.runtimeType)
//         .isNotEmpty) as Stream<S>;
//   }
// }

// typedef EventStateMapper<E extends Type, S> = Map<E, S Function(E event)>;

// import 'dart:async';

// import 'package:flutter/foundation.dart';
// import 'package:rxdart/rxdart.dart';
// import 'state_magic_bloc.dart';

// abstract class BaseBloc<E, S> {
//   BaseBloc({
//     required this.initialState,
//     Function()? onListen,
//     void Function()? onCancel,
//   }) {
//     _stateSubject = BehaviorSubject.seeded(
//       initialState!,
//       onCancel: onCancel,
//       onListen: onListen,
//     );

//     _init();
//   }

//   late StreamSubscription _mapSubscription;
//   late StreamSubscription _inputSubscription;

//   void _init() {
//     _inputSubscription = _eventSubject.stream.listen((e) {
//       _mapSubscription =
//           mapEventToState(e).listen((s) => _stateSubject.sink.add(s));
//     });
//   }

//   /// the initialinputdata
//   final S initialState;

//   /// subject that controls the input of "events"
//   final BehaviorSubject<E> _eventSubject = BehaviorSubject();

//   /// subject that controls the output of "states"
//   late BehaviorSubject<S> _stateSubject;

//   /// stream of the input topic
//   Stream<E> get events => _eventSubject.stream;

//   /// stream of the output topic "state"
//   Stream<S> get stateStream => _stateSubject.stream;

//   /// gets the current state of the bloc / last value emitted by the output stream
//   S? get state => _stateSubject.value;

//   ///
//   StreamSubscription<E> hookIntoEvents(void Function(E) hook) =>
//       events.listen(hook);

//   StreamSubscription<S> hookIntoStates(void Function(S) hook) =>
//       stateStream.listen(hook);

//   void add(E input) {
//     if (isDisposed) return;
//     _eventSubject.sink.add(input);
//   }

//   @protected
//   @nonVirtual
//   void addToOutput(S output) {
//     _stateSubject.sink.add(output);
//   }

//   Stream<S> mapEventToState(E event);

//   bool isDisposed = false;

//   void dispose() {
//     _eventSubject.close();
//     _stateSubject.close();
//     _mapSubscription.cancel();
//     _inputSubscription.cancel();
//     isDisposed = true;
//   }
// }
// // basebloc
// // ->
// // refreshable bloc
// // ->
// // paginationbloc
// // querybloc
// // querypaginationbloc

// import 'dart:async';

// import 'package:event_bus/event_bus.dart';
// import 'package:flutter/widgets.dart';

// abstract class IStateMagicScope<ET> {
//   Stream<RET> stream<RET extends ET>();
//   StreamSubscription<RET> listen<RET extends ET>(
//       void Function(RET event) callback, int id);

//   void fire(Object event);
// }

// class StateMagicScope<ET> extends InheritedWidget
//     implements IStateMagicScope<ET> {
//   final Widget child;

//   StateMagicScope({
//     Key? key,
//     required this.child,
//   }) : super(key: key, child: child);

//   @override
//   bool updateShouldNotify(covariant InheritedWidget oldWidget) {
//     return false;
//   }

//   final EventBus _eventBus = EventBus();

//   final _subscriptions = Map<int, SubscriptionContainer<ET>>();

//   Stream<RET> stream<RET extends ET>() {
//     return _eventBus.on<RET>();
//   }

//   StreamSubscription<RET> listen<RET extends ET>(
//       void Function(RET event) callback, int id) {
//     // ignore: cancel_subscriptions
//     final subscription = _eventBus.on<RET>().listen(callback);
//     SubscriptionContainer? subscriptionContainer = _subscriptions[id];
//     subscriptionContainer == null
//         ? _subscriptions[id] = SubscriptionContainer([subscription])
//         : subscriptionContainer.add(subscription);
//     return subscription;
//   }

//   void cancel<RET>(int id) {
//     _subscriptions[id]?.cancel();
//   }

//   void fire(Object event) {
//     _eventBus.fire(event);
//   }

//   static StateMagicScope of(BuildContext context) {
//     final StateMagicScope? result =
//         context.dependOnInheritedWidgetOfExactType<StateMagicScope>();
//     assert(result != null, 'No FrogColor found in context');
//     return result!;
//   }
// }

// class SubscriptionContainer<ET> {
//   final List<StreamSubscription<ET>> _subscriptions;

//   SubscriptionContainer([this._subscriptions = const []]);

//   StreamSubscription<RET>? get<RET extends ET>() {
//     final matches = _subscriptions.whereType<StreamSubscription<RET>>();
//     if (matches.isEmpty) {
//       return null;
//     }
//     return matches.first;
//   }

//   void add(StreamSubscription<ET> subscription) {
//     if (_subscriptions.contains(subscription)) {
//       return;
//     }
//     _subscriptions.add(subscription);
//   }

//   void cancel<ET>() {
//     _subscriptions.whereType<StreamSubscription<ET>>().first.cancel();
//   }
// }
